package com.unclouded.android;

/**
 * Manages the established network connection.
 * 
 * <p>A {@link Network} instance is returned as the result of invoking
 * {@link Unclouded#goOnline() goOnline()} on the {@link Unclouded} event loop.<br>
 * It enables to install one or more {@link NetworkListener} objects in order
 * to keep track of the network status.</p>
 *
 */
public class Network {
	
	/**
	 * Install a {@link NetworkListener} to monitor the network status.
	 * 
	 * @param listener  used to trigger callback methods when the state of the network changes.
	 */
	public void whenever(NetworkListener listener){	}
	
	
	/**
	 * Cancel all listeners of monitoring the state of the network.
	 * 
	 */
	public void cancel(){ }
	
	
	/**
	 * Returns a string representation of a Network object. 
	 * 
	 * @return a string representation of the network.
	 */
	public String toString(){ return "[Network]"; }
	
}
