package com.unclouded.android;


/**
 *  Enables to manage a service publication.
 *  
 * <p>A {@link ServicePublication} instance is returned as the result of broadcasting a service by 
 * invoking the {@link Unclouded#broadcast(TypeTag, Double) broadcast} method on 
 * the {@link Unclouded} event loop.<br>
 * It enables to cancel the service publication at some later point in time.</p>
 *
 */
public class ServicePublication {
	
	
	/**
	 * Cancel the corresponding service publication.
	 * 
	 * <p>This cause the service to disconnect from the network:
	 * devices that have discovered this service before, trigger a 
	 * {@link ServiceListener#isDisconnected(Object) isDisconnected}
	 * notification; other devices are not able to discover 
	 * the service anymore.</p>
	 */
	public void cancel(){ };
	
	
	/**
	 * Returns a string representation of a ServicePublication object. 
	 * 
	 * @return a string representation of the service publication.
	 */
	public String toString(){ return "[ServicePublication]"; }
	
	

}
