package com.unclouded.android;

/**
 *  Enables to manage a service subscription.
 *  
 * <p>A {@link ServiceSubscription} instance is returned as the result of invoking the
 * {@link Unclouded#when(TypeTag, ServiceListener) when} or 
 * {@link Unclouded#whenever(TypeTag, ServiceListener) whenever} method on 
 * the {@link Unclouded} event loop.<br>
 * It enables to cancel the service subscription at some later point in time.</p>
 *
 */
public class ServiceSubscription {
	
	/**
	 * Cancel the corresponding service subscription.
	 * This implies that no notifications are triggered anymore for the
	 * service(s) that was(were) discovered by this subscription. 
	 */
	public void cancel(){}
	
	
	/**
	 * Returns a string representation of a ServiceSubscription object. 
	 * 
	 * @return a string representation of the service subscription.
	 */
	public String toString(){ return "[ServiceSubscription]"; }
	
}
