package com.unclouded.android.cmd;

import java.io.Serializable;

import com.unclouded.android.TypeTag;
import com.unclouded.android.comm.Address;
import com.unclouded.android.comm.CommunicationBus;
import com.unclouded.android.ids.ServiceId;
import com.unclouded.android.internal.InternalEventLoop;
import com.unclouded.android.services.DataService;


public class CMDProvideDataService extends Command {
	
	private static final long serialVersionUID = -1205984459736801225L;

	private final TypeTag typeTag;
	private final ServiceId serviceId;
	private final Serializable data;	
	
	public CMDProvideDataService(TypeTag typeTag, DataService service) {
		super("provideDataService");
		this.data = service.getData();
		this.serviceId = service.getServiceId();
		this.typeTag = typeTag;
	}
	
	public void send(CommunicationBus dispatcher) {
		dispatcher.sendAsyncMulticast(this);
	}
	
	public void sendTo(CommunicationBus dispatcher, Address recipientActor){
		dispatcher.sendAsyncUnicast(this, recipientActor);
	}
	
	public void uponReceiptBy(InternalEventLoop remoteHost, Address senderAddress) {
		remoteHost.event_dataServiceJoined(typeTag, serviceId, data);
	}
	
}