package com.unclouded.android.cmd;

import com.unclouded.android.TypeTag;
import com.unclouded.android.comm.Address;
import com.unclouded.android.comm.CommunicationBus;
import com.unclouded.android.ids.ServiceId;
import com.unclouded.android.internal.InternalEventLoop;
import com.unclouded.android.services.ObjectService;


public class CMDProvideObjectService extends Command {
	
	private static final long serialVersionUID = -1205984459736801225L;

	private final TypeTag typeTag;
	private ServiceId serviceId;	
	
	public CMDProvideObjectService(TypeTag typeTag, ObjectService service) {
		super("provideObjectService");
		this.serviceId = service.getServiceId();
		this.typeTag = typeTag;
	}
	
	public void send(CommunicationBus dispatcher) {
		dispatcher.sendAsyncMulticast(this);
	}
	
	public void sendTo(CommunicationBus dispatcher, Address recipientActor){
		dispatcher.sendAsyncUnicast(this, recipientActor);
	}
	
	public void uponReceiptBy(InternalEventLoop remoteHost, Address senderAddress) {
		remoteHost.event_objectServiceJoined(typeTag, serviceId);
	}
	
}