package com.unclouded.android.cmd;

import java.io.Serializable;

import com.unclouded.android.comm.Address;
import com.unclouded.android.comm.CommunicationBus;
import com.unclouded.android.ids.PromiseId;
import com.unclouded.android.internal.InternalEventLoop;
import com.unclouded.android.remoteref.Letter;


public class CMDTransmitLetterReply extends Command {
	
	private static final long serialVersionUID = -3003897590511186824L;
	
	private final Serializable answer;
	private final PromiseId futureId;
	
	public CMDTransmitLetterReply(Letter letter, Serializable answer) {
		super("TransmitLetterReply("+letter+")");
		this.answer = answer;
		this.futureId = letter.getPromiseId();
	}
	
	public void send(CommunicationBus dispatcher, Address recipientVM) {
		dispatcher.sendSynchronousUnicast(this, recipientVM);
	}
	
	public void uponReceiptBy(InternalEventLoop remoteHost, Address senderAddress) {
		remoteHost.event_letterReplyReceived(futureId, answer);
	}
}

