package com.unclouded.android.ids;

import java.io.Serializable;
import java.util.Random;

public class PromiseId implements Serializable {
	
	private static final long serialVersionUID = -8191069081930433624L;
	private static final Random generator_ = new Random(System.currentTimeMillis());
	
	private final long promiseId;

	public PromiseId() {
		promiseId = generator_.nextLong();
	}
	
	public int hashCode() {
		return (int) promiseId;
	}
	
	public boolean equals(Object other) {
		if (other instanceof PromiseId) {
			PromiseId id = (PromiseId) other;
			return (id.promiseId == promiseId);
		} else {
			return false;
		}
	}
	
	public String toString() {
		return "Promise["+promiseId+"]";
	}
	

}
