package com.unclouded.android.internal;

import java.net.InetAddress;
import java.util.ArrayList;

import com.unclouded.android.Network;
import com.unclouded.android.NetworkListener;

public class InternalNetwork extends Network {
	
private ArrayList<NetworkListener> listeners;
	
	public InternalNetwork(){
		listeners = new ArrayList<NetworkListener>();
	}
	
	public void whenever(NetworkListener listener){
		listeners.add(listener);
	}
	
	public void cancel(){
		listeners.clear();
	}
	
	public void triggerIsOnline(InetAddress ipAddress){
		for(NetworkListener listener : listeners){
			listener.isOnline(ipAddress);
		}
	}
	
	public void triggerIsOffline(InetAddress ipAddress){
		for(NetworkListener listener : listeners){
			listener.isOffline(ipAddress);
		}
	}
	
	public void triggerIsConnectedTo(InetAddress ipAddress){
		for(NetworkListener listener : listeners){
			listener.isConnectedTo(ipAddress);
		}
	}
	
	public void triggerIsDisconnectedFrom(InetAddress ipAddress){
		for(NetworkListener listener : listeners){
			listener.isDisconnectedFrom(ipAddress);
		}
	}


}
