package com.unclouded.android.internal;
import java.io.Serializable;

import com.unclouded.android.Promise;
import com.unclouded.android.PromiseListener;
import com.unclouded.android.ids.PromiseId;

public class InternalPromise extends Promise {
	
	private final PromiseId promiseId;
	private InternalPromiseListener<? extends Serializable> listener;
	
	public InternalPromise(){
		promiseId = new PromiseId();
	}
	
	public void resolve(Serializable arg){
		if(listener != null){
			listener.triggerOnResolved(arg);
		}
	}

	public PromiseId getPromiseId() {
		return promiseId;
	}

	@Override
	public void when(PromiseListener<? extends Serializable> listener) {
		this.listener = new InternalPromiseListener<Serializable>(listener);	
	}

}
