package com.unclouded.android.internal;

import java.io.Serializable;

import com.unclouded.android.Promise;
import com.unclouded.android.RemoteReference;
import com.unclouded.android.ids.ServiceId;
import com.unclouded.android.services.RemoteObjectService;

public class InternalRemoteReference extends RemoteReference {
	
	private final RemoteObjectService remoteService;

	public InternalRemoteReference(RemoteObjectService remoteService){
		this.remoteService = remoteService;		
	}	
	
	public Promise asyncInvoke(String selector, Serializable... args){
		return remoteService.asyncInvoke(selector, args);
	}
	
	public ServiceId getServiceId(){
		return remoteService.getServiceId();
	}
	
	public boolean equals(Object o) {
		return (o instanceof RemoteReference) 
				&& (((InternalRemoteReference) o).getServiceId()).equals(this.getServiceId());
	}

	public int hashCode() {
		return remoteService.hashCode();
	}
	
		

}
