package com.unclouded.android.internal;

import com.unclouded.android.ServicePublication;
import com.unclouded.android.TypeTag;
import com.unclouded.android.comm.CommunicationBus;
import com.unclouded.android.ids.PublicationId;
import com.unclouded.android.services.Service;

public class InternalServicePublication extends ServicePublication {
	
	private TypeTag typeTag;
	private InternalEventLoop eventLoop;
	private Service service;
	private PublicationId publicationId;
	
	public InternalServicePublication(TypeTag typeTag, Service service, InternalEventLoop eventLoop){
		this.typeTag = typeTag;
		this.eventLoop = eventLoop;
		this.service = service;
		this.publicationId = new PublicationId();
	}
	
	public void cancel(){
		eventLoop.cancelServicePublication(publicationId);
	}
	
	public TypeTag getTypeTag(){
		return typeTag;
	}
	
	public Service getService(){
		return service;
	}
	
	public PublicationId getId(){
		return publicationId;
	}
	
	protected void publish(CommunicationBus dispatcher){
		service.publish(dispatcher, typeTag);
	}

}
