package com.unclouded.android.internal;

import com.unclouded.android.ServiceSubscription;
import com.unclouded.android.TypeTag;
import com.unclouded.android.services.RemoteService;
import com.unclouded.android.services.RemoteServiceListener;

public abstract class InternalServiceSubscription extends ServiceSubscription {
	
	protected TypeTag typeTag;
	protected RemoteServiceListener<?> listener;
	protected InternalEventLoop host;
	
	public InternalServiceSubscription(TypeTag typeTag, RemoteServiceListener<?> listener, InternalEventLoop host){
		this.typeTag = typeTag;
		this.listener = listener;
		this.host = host;
	}
	
	public TypeTag getTypeTag(){
		return typeTag;
	}
	
	public RemoteServiceListener<?> getListener(){
		return listener;
	}
	
	public abstract boolean serviceJoined(RemoteService service);
	
	public void notifyDisconnection(RemoteService service){
		listener.uponDisconnecting(service);
	}

}
