package com.unclouded.android.logging;

import java.util.HashMap;
import android.util.Log;

public class Logger {
	
	/** When loggers are initialised with this setting, all messages (including debug info) are being logged. */ 
	public static final int _DEBUG_LEVEL_ = 1;
	/** When loggers are initialised with this setting, all messages except for debug info are being logged. */ 
	public static final int _WARN_LEVEL_  = 2;
	/** When loggers are initialised with this setting, errors as well as info (e.g. regarding connection status) is being logged. */ 
	public static final int _INFO_LEVEL_  = 3;
	/** When loggers are initialised with this setting, all errors (including tolerable ones) are reported. */ 
	public static final int _ERROR_LEVEL_ = 4;
	/** When loggers are initialised with this setting, only fatal errors are reported. */ 
	public static final int _FATAL_LEVEL_ = 5;
	
	private static final HashMap<String, Logger> LOGS = new HashMap<String, Logger>();
	private final String name;
	
	private Logger(String name_) {
		name = name_;
	}
	
	public static Logger getInstance(String name) {
		Logger logger = (Logger) LOGS.get(name);
		if (logger == null) {
			logger = new Logger(name);
			LOGS.put(name, logger);
		}
		return logger;
	}
	
	/**
	 * Reports debugging information to be logged. Such messages are ignored when the logger has
	 * its priority set to be higher than or equal to WARNING. 
	 * @param msg the message to be logged.
	 */
	public void debug(String msg) {
		Log.d(name, msg);
	}
	

}
