package com.unclouded.android.remoteref;

import java.io.Serializable;

import com.unclouded.android.ids.EventLoopId;
import com.unclouded.android.ids.PromiseId;
import com.unclouded.android.ids.ServiceId;


public class Letter implements Serializable {
	
	private static final long serialVersionUID = -2552302723719947657L;
	
	private final EventLoopId senderEventLoopId;
	private final ServiceId receiver;
	private final PromiseId promiseId;
	private final String selector;
	private final Serializable[] args;
	
	public Letter(PromiseId futureId, ServiceId receiver, String selector, Serializable...args){
		this.senderEventLoopId = receiver.getActorId();
		this.promiseId = futureId;
		this.receiver = receiver;
		this.selector = selector;
		this.args = args;		
	}
	
	public EventLoopId getSendingActorId(){
		return senderEventLoopId;
	}

	public ServiceId getReceivingServiceId() {
		return receiver;
	}

	public String getSelector() {
		return selector;
	}

	public Serializable[] getArguments() {
		return args;
	}

	public PromiseId getPromiseId() {
		return promiseId;
	}
	
	public String toString() { return "Letter[to:"+senderEventLoopId+"]"; }	

}
