package com.unclouded.android.services;

import java.io.Serializable;

import com.unclouded.android.TypeTag;
import com.unclouded.android.cmd.CMDProvideDataService;
import com.unclouded.android.comm.CommunicationBus;
import com.unclouded.android.internal.InternalEventLoop;
import com.unclouded.android.logging.Logging;

public class DataService extends Service {
	
	final private Serializable data;

	public DataService(Serializable data, InternalEventLoop eventLoop) {
		super(eventLoop);
		this.data = data;
	}
	
	public Serializable getData(){
		return data;
	}
	
	public void publish(CommunicationBus dispatcher, TypeTag typeTag) {
		new CMDProvideDataService(typeTag, this).send(dispatcher);
		Logging.Actor_LOG.debug("Service "+typeTag+" exported");
	}

}
