package com.unclouded.android.services;

import java.util.ArrayList;

import com.unclouded.android.TypeTag;
import com.unclouded.android.internal.InternalEventLoop;
import com.unclouded.android.internal.InternalServiceSubscription;

public class MultiServiceSubscription extends InternalServiceSubscription {
	
	private ArrayList<RemoteService> discoveredServices;
	
	public MultiServiceSubscription(TypeTag typeTag, RemoteServiceListener<?> listener, InternalEventLoop host){
		super(typeTag, listener, host);
		discoveredServices = new ArrayList<RemoteService>();
	}
	
	public void cancel(){
		for(RemoteService service : discoveredServices){
			service.subscriptionCanceled(this);
		}
		host.cancelServiceSubscription(typeTag, this);
	}

	public boolean serviceJoined(RemoteService service){
		if(discoveredServices.contains(service)){ // Reconnection
			service.hasReconnected();
			if(service.isConnected()){ listener.uponReconnecting(service); }
		} else {
			discoveredServices.add(service);
			service.hasBeenDiscoveredBy(this);
			if(service.isConnected()){ listener.uponDiscovering(service); }
		}
		return true;
	}
	

	
}
