package com.unclouded.android.services;

import java.util.ArrayList;

import com.unclouded.android.ids.ServiceId;
import com.unclouded.android.internal.InternalServiceSubscription;

public abstract class RemoteService {
	
	final protected ServiceId serviceId;
	final private ArrayList<InternalServiceSubscription> subscriptions;
	private boolean isConnected;
	
	public RemoteService(ServiceId serviceId){
		this.serviceId = serviceId;
		this.subscriptions = new ArrayList<InternalServiceSubscription>();
		this.isConnected = true;
	}
	
	public ServiceId getServiceId(){
		return serviceId;
	}
	
	public boolean isConnected(){
		return isConnected;
	}
	
	public abstract Object getPublicValue();
	
	public void hasBeenDiscoveredBy(InternalServiceSubscription subscription){
		subscriptions.add(subscription);
	}
	
	public void hasDisconnected(){
		if(isConnected){
			isConnected = false;
			for(InternalServiceSubscription subscription: subscriptions){
				subscription.notifyDisconnection(this);
			}
		}
	}
	
	public void hasReconnected(){
		isConnected = true;
	}
	
	public void subscriptionCanceled(InternalServiceSubscription subscription){
		subscriptions.remove(subscription);
	}

}
