package com.unclouded.android.services;

import com.unclouded.android.ServiceListener;

@SuppressWarnings("unchecked")
public class RemoteServiceListener<T extends Object> {
	
	private ServiceListener<T> listener;
	
	public RemoteServiceListener(ServiceListener<? extends Object> listener){
		this.listener = (ServiceListener<T>) listener;
	}
	
	public void uponDiscovering(RemoteService remoteService){
		T returnValue = (T) remoteService.getPublicValue();
		listener.isDiscovered(returnValue);
	}
	
	public void uponDisconnecting(RemoteService remoteService){
		T returnValue = (T) remoteService.getPublicValue();
		listener.isDisconnected(returnValue);
	}
	
	public void uponReconnecting(RemoteService remoteService){
		T returnValue = (T) remoteService.getPublicValue();
		listener.isReconnected(returnValue);
	}

}
