package com.unclouded.android.services;

import com.unclouded.android.TypeTag;
import com.unclouded.android.internal.InternalEventLoop;
import com.unclouded.android.internal.InternalServiceSubscription;

public class SingleServiceSubscription extends InternalServiceSubscription {
	
	private RemoteService service;
	
	public SingleServiceSubscription(TypeTag typeTag, RemoteServiceListener<?> listener, InternalEventLoop host){
		super(typeTag, listener, host);
	}
	
	public void cancel(){
		if(service != null){
			service.subscriptionCanceled(this);
		}
		host.cancelServiceSubscription(typeTag, this);
	}
	
	
	public boolean serviceJoined(RemoteService newService){
		if(service != null && service==newService && service.isConnected()){
			service.hasReconnected();
			listener.uponReconnecting(service); 
			return true;
		} else if(service == null && newService.isConnected()){
			service = newService;
			service.hasBeenDiscoveredBy(this);
			listener.uponDiscovering(service);
			return true;
		}
		return false;
	}
	
	
	
}
